/*
 * lab1.c
 */

#include "lcd.h"

#include <avr/io.h>
#include <util/delay.h>

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MORSE_LUNG  3
#define MORSE_SCURT 1

int pini_A[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
int pini_B[8] = {PB0, PB1, PB2, PB3, PB4, PB5, PB6, PB7};

int TOP = 0, BOT = 0x40 | 0x80;

uint8_t activeBattery = 0;

/**
 * Intoarce procentul de putere ramasa in baterie, in functie
 * de capacitatea actuala si curba de descare a acesteia.
 */
char AApercentage(int current){

	// TODO: Estimeaza capacitate ramasa

	return current;

}


/**
 * Intoarce procentul de putere ramasa in baterie, in functie
 * de capacitatea actuala si curba de descare a acesteia.
 */
char AAApercentage(int current){

	// TODO: Estimeaza capacitate ramasa
	return current;
}

/**
 * Modifica variabila globala pentru a specifica bateria
 * careia i se citeste capacitatea. De asemenea aprinde ledul
 * corespunzator bateriei si stinge fostul led parins.
 */
void activateBattery(uint8_t index){
	// Opreste ledul aprins anterior
	int off = pini_B[1 + 2 * activeBattery];
	PORTB &= ~(1 << off);
	
	// Aprinde noul led
	int on = pini_B[1 + 2 * index];
	PORTB |= (1 << on);
	
	activeBattery = index;
}

/**
 * Enable ADC with:
 * reference AVCC with external capacitor at AREF pin
 * without left adjust of conversion result
 * no auto-trigger
 * no interrupt
 * prescaler at 128
 */
void ADC_init(void)
{
	ADMUX = (1 << REFS0);
	ADCSRA = (1 << ADEN) | (7 << ADPS0);
}


/**
 * start ADC conversion on "channel"
 * wait for completion
 * return the result
 */
int ADC_get(uint8_t channel)
{
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC));

	return ADC;	
}

void code(){
	/*
	 * Seteaza pinii de intrare / iesire:
	 * Intrare: (butoane): PB0, PB2
	 * Iesire:  (leduri):  PB1, PB3
	 * TODO: Bateriile
	 */
	
	// Setezi pinii de intrare
	DDRB &= ~(1 << PB0);
	DDRB &= ~(1 << PB2);
	//DDRB &= ~(1 << PB4);
	//DDRB &= ~(1 << PB6);
	
	// Activez rezistentele de pull-up
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB2);
	//PORTB |= (1 << PB4);
	//PORTB |= (1 << PB6);
	
	// Setez pinii de iesire
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB3);
	//DDRB |= (1 << PB5);
	//DDRB |= (1 << PB7);
	
	while(1){
	
		// Cand se apasa pe butoane se selecteaza bateria activa
		if ((PINB & (1 << PB0)) == 0 && activeBattery != 0) {
			activateBattery(0);
			char* mesaj = "bateria: 1    AA";
			LCD_printAt(TOP, mesaj);
		}
		if ((PINB & (1 << PB2)) == 0 && activeBattery != 1) {
			activateBattery(1);
			char* mesaj = "bateria: 2   AAA";
			LCD_printAt(TOP, mesaj);
		}
		
		/*
		if ((PINB & (1 << PB4)) == 0 && activeBattery != 2) {
			activateBattery(2);
		}
		if ((PINB & (1 << PB6)) == 0 && activeBattery != 3) {
			activateBattery(3);
		}
		*/
		
		int val = ADC_get(activeBattery);
		// TODO: citeste tensiune la capete
		int percentage = -1;
		
		switch(activeBattery){
			case 0:
				percentage = AApercentage(val);
				break;
			case 1:
				percentage = AAApercentage(val);
				break;
				
			case 2:
			
				break;
			
			case 3:
			
				break;
			
			default:
				percentage = 0;
				break;
		}
		
		char number[17];
		char buffer[17];
		sprintf(number,"%d", percentage);
		sprintf(buffer, "%s", number);
		memset(buffer + strlen(number), ' ', 16 - strlen(number));
		LCD_printAt(BOT, buffer);
		_delay_ms(500);
	}
}


int main()
{
    LCD_init();
	ADC_init();
	code();
    return 0;
}

